var FirstSchoolDayCovered = "20230801";
var LastSchoolDayCovered = "20250630";
var FirstLastDays = ["20230905", "20240626", "20240903", "20250625"];
var HolidayDays = [
  "20230807",
  "20230904",
  "20230930",
  "20231009",
  "20231111",
  "20231225",
  "20231226",
  "20240101",
  "20240219",
  "20240329",
  "20240401",
  "20240520",
  "20240701",
  "20240805",
  "20240902",
  "20240930",
  "20241014",
  "20241111",
  "20241225",
  "20241226",
  "20250101",
  "20250217",
  "20250418",
  "20250421",
  "20250519",
  "20250701",
];
var PDDays = [
  "20230831",
  "20230925",
  "20231020",
  "20231114",
  "20240131",
  "20240220",
  "20240311",
  "20240426",
  "20240830",
  "20241011",
  "20241030",
  "20241031",
  "20250129",
  "20250416",
  "20250417",
  "20250609",
];
var OperationalDays = [
  "20230901",
  "20240621",
  "20240627",
  "20240829",
  "20250626",
];
var TeachersConventionDays = ["20240229", "20240301", "20250227", "20250228"];
var TeachersDayInLieuDays = ["20231109", "20240521", "20241101", "20250521"];
var BoardApprovedDays = ["20231110", "20231113", "20240522", "20250520"];
var WinterSpringBreakDays = [
  "20231227",
  "20231228",
  "20231229",
  "20240102",
  "20240103",
  "20240104",
  "20240105",
  "20240325",
  "20240326",
  "20240327",
  "20240328",
  "20241223",
  "20241224",
  "20241227",
  "20241230",
  "20241231",
  "20250102",
  "20250103",
  "20250324",
  "20250325",
  "20250326",
  "20250327",
  "20250328",
];
function CheckSchoolOff(SelectedDate, FirstLast) {
  var returnValue = "";
  returnValue = "";
  if (
    SelectedDate < FirstSchoolDayCovered ||
    SelectedDate > LastSchoolDayCovered
  ) {
    returnValue = "n/a";
    return returnValue;
  }
  var j;
  for (j = 0; j <= Len(HolidayDays) - 1; j++) {
    if (SelectedDate == HolidayDays[j]) {
      //Check for public holiday
      returnValue = "publicholiday";
      return returnValue;
    }
  }
  //Do this after publicholiday so Civic holiday and Canada day get picked up
  if (
    SelectedDate < FirstLastDays[0] ||
    (SelectedDate > FirstLastDays[1] && SelectedDate < FirstLastDays[2]) ||
    SelectedDate > FirstLastDays[3]
  ) {
    //Check for summer holidays
    returnValue = "summer";
    return returnValue;
  }
  for (j = 0; j <= Len(WinterSpringBreakDays) - 1; j++) {
    if (SelectedDate == WinterSpringBreakDays[j]) {
      //Check for winter/spring break
      returnValue = "winter/spring";
      return returnValue;
    }
  }
  for (j = 0; j <= Len(PDDays) - 1; j++) {
    if (SelectedDate == PDDays[j]) {
      //Check for personal days
      returnValue = "personalday";
      return returnValue;
    }
  }
  for (j = 0; j <= Len(OperationalDays) - 1; j++) {
    if (SelectedDate == OperationalDays[j]) {
      //Check for operational day
      returnValue = "operational";
      return returnValue;
    }
  }
  for (j = 0; j <= Len(TeachersConventionDays) - 1; j++) {
    if (SelectedDate == TeachersConventionDays[j]) {
      //Check for teachers' convention
      returnValue = "convention";
      return returnValue;
    }
  }
  for (j = 0; j <= Len(TeachersDayInLieuDays) - 1; j++) {
    if (SelectedDate == TeachersDayInLieuDays[j]) {
      //Check for teachers' day in lieu
      returnValue = "dayinlieu";
      return returnValue;
    }
  }
  for (j = 0; j <= Len(BoardApprovedDays) - 1; j++) {
    if (SelectedDate == BoardApprovedDays[j]) {
      //Check for board approved non-instructional day
      returnValue = "boardapproved";
      return returnValue;
    }
  }
  if (FirstLast) {
    for (j = 0; j <= Len(FirstLastDays) - 1; j++) {
      if (SelectedDate == FirstLastDays[j]) {
        //Check for first/last day of school
        returnValue = "first/last";
        return returnValue;
      }
    }
  }
  return returnValue;
}
