Dim ScheduleArray()
Const SCHEDYEAR = 0
Const SCHEDMONTH = 1
Const SCHEDDAY = 2
Const SCHEDWEEKDAY = 3
Dim SelectedYear
Dim SelectedMonth
Sub ScheduleForm_onshow()
  Dim Row, Col
  Dim ColWidth = Int(ScreenWidth/7)-1
  For Col = 0 To 6
    DateGrid.setColumnWidth(Col,ColWidth & "px")
  Next
  For Row = 0 To 6
    DateGrid.setRowHeight(Row,"52px")
  Next
  DateGrid.Width = (ColWidth * 7) + 2
  DateGrid.style.tableLayout = "fixed"
  DateGrid.style.textAlign   = "center"
  DateGrid.Left     = CenterInForm(SysInfo(0),DateGrid.Width)
  EPSBLabel.Left    = DateGrid.Left
  MonthLabel.Width  = DateGrid.Width
  MonthLabel.Left   = DateGrid.Left
  Back1YearButton.Top = DateGrid.Top + DateGrid.Height + 4
  Back1MonthButton.Top = Back1YearButton.Top
  CurrentButton.Top = Back1YearButton.Top
  Forward1MonthButton.Top = Back1YearButton.Top
  Forward1YearButton.Top = Back1YearButton.Top
  Back1YearButton.Left  = DateGrid.Left
  Back1MonthButton.Left = Back1YearButton.Left + Back1YearButton.Width + 5
  Forward1YearButton.Left = DateGrid.Left + DateGrid.Width - Forward1YearButton.Width
  Forward1MonthButton.Left = Forward1YearButton.Left - Forward1MonthButton.Width - 5
  CurrentButton.Left = CenterInForm(SysInfo(0),CurrentButton.Width)
  ContactsButton.Left = ScreenWidth - 95
  Dim DaysInMonth = [0,31,28,31,30,31,30,31,31,30,31,30,31]
  Dim MonthDays, DayOfWeek
  Dim ScheduleYear, ScheduleMonth, ScheduleDay
  Dim EndYear, EndMonth
  Dim End
  ScheduleArray = []
  ScheduleYear  = Number(Left(FirstSchoolDayCovered,4))
  EndYear       = Number(Left(LastSchoolDayCovered,4))
  ScheduleMonth = Number(Mid(FirstSchoolDayCovered,5,2))
  EndMonth      = Number(Mid(LastSchoolDayCovered,5,2))
  If Year(Date()) < ScheduleYear Or (Year(Date()) = ScheduleYear And Month(Date()) < ScheduleMonth) Then
    SelectedYear  = ScheduleYear
    SelectedMonth = ScheduleMonth
  ElseIf Year(Date()) > EndYear Or (Year(Date()) = EndYear And Month(Date()) > EndMonth) Then
    SelectedYear  = EndYear
    SelectedMonth = EndMonth
  Else
    SelectedYear  = Year(Date)
    SelectedMonth = Month(Date)
  End If
  Do
    If ScheduleMonth = 2 And (ScheduleYear Mod 4) = 0 Then MonthDays = 29 Else MonthDays = DaysInMonth[ScheduleMonth]
    For ScheduleDay = 1 To MonthDays
      DayOfWeek = Weekday(ScheduleMonth & "/" & ScheduleDay & "/" & ScheduleYear)
      Push(ScheduleArray,[ScheduleYear,ScheduleMonth,ScheduleDay,DayOfWeek])
    Next
    If ScheduleYear = EndYear And ScheduleMonth = EndMonth Then Exit Do
    ScheduleMonth = ScheduleMonth + 1
    If ScheduleMonth > 12 Then
      ScheduleMonth = 1
      ScheduleYear = ScheduleYear + 1
    End If
  Loop
  DisplayScheduleForm()
End Sub

Dim Months = ["","January","February","March","April","May","June","July","August","September","October","November","December"]

Sub DisplayScheduleForm()
  Dim Row, Col
  MonthLabel.text = Months[SelectedMonth] & " " & SelectedYear
  For Row = 1 To 6
    For Col = 0 To 6
      DateGrid.cell(Row,Col).style.backgroundColor = vbWhite
      DateGrid.cell(Row,Col).style.color = vbBlack
      DateGrid.cell(Row,Col).style.fontWeight = "normal"
      DateGrid.cell(Row,Col).style.fontSize = "20px"
      DateGrid.cell(Row,Col).style.fontStyle = "normal"
      DateGrid.setValue(Row,Col,"&nbsp;")
    Next
  Next

  Dim Start, i, j
'  Start = ((SelectedYear - Year(Date)) * 365) + ((SelectedMonth - 1) * 29) 'Position close to current selection to save number of entries to scan
  For i = 0 To Len(ScheduleArray)-1
    If ScheduleArray[i][SCHEDYEAR] = SelectedYear And ScheduleArray[i][SCHEDMONTH] = SelectedMonth Then
      Start = i
      Exit For
    End If
  Next
  
  Dim GridRow = 1
  Dim SelectedDate, SpecialDay
  For i = Start To Len(ScheduleArray)-1
    If ScheduleArray[i][SCHEDYEAR] = SelectedYear And ScheduleArray[i][SCHEDMONTH] = SelectedMonth Then
      SelectedDate = CDate(SelectedMonth & "/" & ScheduleArray[i][SCHEDDAY] & "/" & SelectedYear)
      SelectedDate = FormatDateTime(SelectedDate,vbYYYYMMDD)
      DateGrid.setValue(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1,ScheduleArray[i][SCHEDDAY])
      SpecialDay = CheckSchoolOff(SelectedDate,True)
      If SpecialDay <> "" Then
        If SpecialDay = "summer" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(230,231,233)
        ElseIf SpecialDay = "first/last" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(244,119,33)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "winter/spring" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(87,88,90)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "publicholiday" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(68,199,238)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "personalday" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(76,175,86)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "operational" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(232,184,9)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "convention" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(238,29,35)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "dayinlieu" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(170,96,21)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        ElseIf SpecialDay = "boardapproved" Then
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(102,70,147)
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.color = vbWhite
          DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
        End If
      ElseIf ScheduleArray[i][SCHEDWEEKDAY] = 1 Or ScheduleArray[i][SCHEDWEEKDAY] = 7 Then 'Check for weekend
        DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.backgroundColor = RGB(230,231,233)
      End If
      If Number(Left(SelectedDate,4)) = Year(Date()) And Number(Mid(SelectedDate,5,2)) = Month(Date()) And Number(Right(SelectedDate,2)) = Day(Date()) Then
        DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontSize   = "32px"
        DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontStyle  = "italic"
        DateGrid.cell(GridRow,ScheduleArray[i][SCHEDWEEKDAY]-1).style.fontWeight = "bold"
      End If
      If ScheduleArray[i][SCHEDWEEKDAY] = 7 Then GridRow = GridRow + 1
    Else
      Exit For
    End If
  Next
End Sub

'Function CheckSchoolOff(SelectedDate,FirstLast)
'  Dim FirstLastDays          = ["20230905","20240626","20240903","20250625"]
'  Dim HolidayDays            = ["20230807","20230904","20230930","20231009","20231111","20231225","20231226","20240101","20240219","20240329","20240401","20240520","20240701","20240805","20240902","20240930","20241014","20241111","20241225","20241226","20250101","20250217","20250418","20250421","20250519","20250701"]
'  Dim PDDays                 = ["20230831","20230925","20231020","20231114","20240131","20240220","20240311","20240426","20240830","20241011","20241030","20241031","20250129","20250416","20250417","20250609"]
'  Dim OperationalDays        = ["20230901","20240621","20240627","20240829","20250626"]
'  Dim TeachersConventionDays = ["20240229","20240301","20250227","20250228"]
'  Dim TeachersDayInLieuDays  = ["20231109","20240521","20241101","20250521"]
'  Dim BoardApprovedDays      = ["20231110","20231113","20240522","20250520"]
'  Dim WinterSpringBreakDays  = ["20231227","20231228","20231229","20240102","20240103","20240104","20240105","20240325","20240326","20240327","20240328","20241223","20241224","20241227","20241230","20241231","20250102","20250103","20250324","20250325","20250326","20250327","20250328"]
'  CheckSchoolOff = ""
'  Dim j
'  For j = 0 To Len(HolidayDays)-1
'    If SelectedDate = HolidayDays[j] Then 'Check for public holiday
'      CheckSchoolOff = "publicholiday"
'      Exit Function
'    End If
'  Next
'  'Do this after publicholiday so Civic holiday and Canada day get picked up
'  If SelectedDate < FirstLastDays[0] Or (SelectedDate > FirstLastDays[1] And SelectedDate < FirstLastDays[2]) Or SelectedDate > FirstLastDays[3] Then 'Check for summer holidays
'    CheckSchoolOff = "summer"
'    Exit Function
'  End If
'  For j = 0 To Len(WinterSpringBreakDays)-1
'    If SelectedDate = WinterSpringBreakDays[j] Then 'Check for winter/spring break
'      CheckSchoolOff = "winter/spring"
'      Exit Function
'    End If
'  Next
'  For j = 0 To Len(PDDays)-1
'    If SelectedDate = PDDays[j] Then 'Check for personal days
'      CheckSchoolOff = "personalday"
'      Exit Function
'    End If
'  Next
'  For j = 0 To Len(OperationalDays)-1
'    If SelectedDate = OperationalDays[j] Then 'Check for operational day
'      CheckSchoolOff = "operational"
'      Exit Function
'    End If
'  Next
'  For j = 0 To Len(TeachersConventionDays)-1
'    If SelectedDate = TeachersConventionDays[j] Then 'Check for teachers' convention
'      CheckSchoolOff = "convention"
'      Exit Function
'    End If
'  Next
'  For j = 0 To Len(TeachersDayInLieuDays)-1
'    If SelectedDate = TeachersDayInLieuDays[j] Then 'Check for teachers' day in lieu
'      CheckSchoolOff = "dayinlieu"
'      Exit Function
'    End If
'  Next
'  For j = 0 To Len(BoardApprovedDays)-1
'    If SelectedDate = BoardApprovedDays[j] Then 'Check for board approved non-instructional day
'      CheckSchoolOff = "boardapproved"
'      Exit Function
'    End If
'  Next
'  If FirstLast Then
'    For j = 0 To Len(FirstLastDays)-1
'      If SelectedDate = FirstLastDays[j] Then 'Check for first/last day of school
'        CheckSchoolOff = "first/last"
'        Exit Function
'      End If
'    Next
'  End If
'End Function  


Sub Back1YearButton_onclick()
  Dim NewSelectedYear
  NewSelectedYear = SelectedYear - 1
  If NewSelectedYear < ScheduleArray[0][SCHEDYEAR] Or (NewSelectedYear = ScheduleArray[0][SCHEDYEAR] And SelectedMonth < ScheduleArray[0][SCHEDMONTH]) Then
'    SelectedYear = ScheduleArray[0][SCHEDYEAR]
'    SelectedMonth = ScheduleArray[0][SCHEDMONTH]
    MsgBox(Months[ScheduleArray[0][SCHEDMONTH]] & ", " & ScheduleArray[0][SCHEDYEAR] & " is the earliest month")
  Else
    SelectedYear = NewSelectedYear
  End If
  DisplayScheduleForm()
End Sub

Sub Back1MonthButton_onclick()
  Dim NewSelectedYear, NewSelectedMonth
  NewSelectedMonth = SelectedMonth - 1
  If NewSelectedMonth < 1 Then 
    NewSelectedYear = SelectedYear - 1
    NewSelectedMonth = 12
  Else
    NewSelectedYear = SelectedYear
  End If
  If NewSelectedYear < ScheduleArray[0][SCHEDYEAR] Or (NewSelectedYear = ScheduleArray[0][SCHEDYEAR] And NewSelectedMonth < ScheduleArray[0][SCHEDMONTH]) Then
'    SelectedYear = ScheduleArray[0][SCHEDYEAR]
'    SelectedMonth = ScheduleArray[0][SCHEDMONTH]
    MsgBox(Months[ScheduleArray[0][SCHEDMONTH]] & ", " & ScheduleArray[0][SCHEDYEAR] & " is the earliest month")
  Else
    SelectedYear = NewSelectedYear
    SelectedMonth = NewSelectedMonth
  End If
  DisplayScheduleForm()
End Sub

Sub CurrentButton_onclick()
  SelectedYear = Year(Date)
  SelectedMonth = Month(Date)
  DisplayScheduleForm()
End Sub

Sub Forward1YearButton_onclick()
  Dim NewSelectedYear
  NewSelectedYear = SelectedYear + 1
  If NewSelectedYear > ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] Or (NewSelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] And SelectedMonth > ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]) Then
'    SelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR]
'    SelectedMonth = ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]
    MsgBox(Months[ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]] & ", " & ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] & " is the latest month") 
  Else
    SelectedYear = NewSelectedYear
  End If
  DisplayScheduleForm()
End Sub

Sub Forward1MonthButton_onclick()
  Dim NewSelectedYear, NewSelectedMonth
  NewSelectedMonth = SelectedMonth + 1
  If NewSelectedMonth > 12 Then 
    NewSelectedYear = SelectedYear + 1
    NewSelectedMonth = 1
  Else
    NewSelectedYear = SelectedYear
  End If
  If NewSelectedYear > ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] Or (NewSelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] And NewSelectedMonth > ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]) Then
'    SelectedYear = ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR]
'    SelectedMonth = ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]
    MsgBox(Months[ScheduleArray[Len(ScheduleArray)-1][SCHEDMONTH]] & ", " & ScheduleArray[Len(ScheduleArray)-1][SCHEDYEAR] & " is the latest month") 
  Else
    SelectedYear = NewSelectedYear
    SelectedMonth = NewSelectedMonth
  End If
  DisplayScheduleForm()
End Sub

Sub ContactsButton_onclick()
  location.href = "https://epsb.ca/contact/"
End Sub