Dim FirstSchoolDayCovered  = "20230801"
Dim LastSchoolDayCovered   = "20250630"
Dim FirstLastDays          = ["20230905","20240626","20240903","20250625"]
Dim HolidayDays            = ["20230807","20230904","20230930","20231009","20231111","20231225","20231226","20240101","20240219","20240329","20240401","20240520","20240701","20240805","20240902","20240930","20241014","20241111","20241225","20241226","20250101","20250217","20250418","20250421","20250519","20250701"]
Dim PDDays                 = ["20230831","20230925","20231020","20231114","20240131","20240220","20240311","20240426","20240830","20241011","20241030","20241031","20250129","20250416","20250417","20250609"]
Dim OperationalDays        = ["20230901","20240621","20240627","20240829","20250626"]
Dim TeachersConventionDays = ["20240229","20240301","20250227","20250228"]
Dim TeachersDayInLieuDays  = ["20231109","20240521","20241101","20250521"]
Dim BoardApprovedDays      = ["20231110","20231113","20240522","20250520"]
Dim WinterSpringBreakDays  = ["20231227","20231228","20231229","20240102","20240103","20240104","20240105","20240325","20240326","20240327","20240328","20241223","20241224","20241227","20241230","20241231","20250102","20250103","20250324","20250325","20250326","20250327","20250328"]
Function CheckSchoolOff(SelectedDate,FirstLast)
  CheckSchoolOff = ""
  If SelectedDate < FirstSchoolDayCovered Or SelectedDate > LastSchoolDayCovered Then
    CheckSchoolOff = "n/a"
    Exit Function
  End If
  Dim j
  For j = 0 To Len(HolidayDays)-1
    If SelectedDate = HolidayDays[j] Then 'Check for public holiday
      CheckSchoolOff = "publicholiday"
      Exit Function
    End If
  Next
  'Do this after publicholiday so Civic holiday and Canada day get picked up
  If SelectedDate < FirstLastDays[0] Or (SelectedDate > FirstLastDays[1] And SelectedDate < FirstLastDays[2]) Or SelectedDate > FirstLastDays[3] Then 'Check for summer holidays
    CheckSchoolOff = "summer"
    Exit Function
  End If
  For j = 0 To Len(WinterSpringBreakDays)-1
    If SelectedDate = WinterSpringBreakDays[j] Then 'Check for winter/spring break
      CheckSchoolOff = "winter/spring"
      Exit Function
    End If
  Next
  For j = 0 To Len(PDDays)-1
    If SelectedDate = PDDays[j] Then 'Check for personal days
      CheckSchoolOff = "personalday"
      Exit Function
    End If
  Next
  For j = 0 To Len(OperationalDays)-1
    If SelectedDate = OperationalDays[j] Then 'Check for operational day
      CheckSchoolOff = "operational"
      Exit Function
    End If
  Next
  For j = 0 To Len(TeachersConventionDays)-1
    If SelectedDate = TeachersConventionDays[j] Then 'Check for teachers' convention
      CheckSchoolOff = "convention"
      Exit Function
    End If
  Next
  For j = 0 To Len(TeachersDayInLieuDays)-1
    If SelectedDate = TeachersDayInLieuDays[j] Then 'Check for teachers' day in lieu
      CheckSchoolOff = "dayinlieu"
      Exit Function
    End If
  Next
  For j = 0 To Len(BoardApprovedDays)-1
    If SelectedDate = BoardApprovedDays[j] Then 'Check for board approved non-instructional day
      CheckSchoolOff = "boardapproved"
      Exit Function
    End If
  Next
  If FirstLast Then
    For j = 0 To Len(FirstLastDays)-1
      If SelectedDate = FirstLastDays[j] Then 'Check for first/last day of school
        CheckSchoolOff = "first/last"
        Exit Function
      End If
    Next
  End If
End Function